﻿using System;
using System.Collections.Generic;
using System.Linq;
using Magic.Utils;

namespace AbilityParser.Ability
{

	class KeywordedActivated : ParsedUnit<IAbility>, IAbility
	{
		public string KeyWord { get; protected set; }

		public KeywordedActivated(string keyword)
		{
			KeyWord = keyword; 
		}

		public static bool TryParse( string text, ref IAbility ability )
		{
			foreach( string meta in CommonTokens.KwAbilitiesWithCost.Where( meta => text.Equals( meta ) ) )
			{
				ability = new KeywordedActivated( meta );
				return true;
			}
			return false;
		}


		public override string ToString()
		{
			return string.Format( "KwA: {0}", KeyWord);
		}

		public AbContext SubParts { get; set; }
	}
}
