﻿using System;
using System.Collections.Generic;
using System.Linq;
using Magic.Utils;

namespace AbilityParser.Ability
{
	class KeywordedStaticAbility : ParsedUnit<IAbility>, IAbility
	{
		public string KeyWord { get; protected set; }
		public int Amount { get; protected set; }

		public static bool TryParse( string text, ref IAbility ability )
		{
			string foundKw = CommonTokens.KwStaticAbilites.FirstOrDefault(kw => String.Compare(text, kw, true) == 0);
			if (!string.IsNullOrWhiteSpace(foundKw))
			{
				ability = new KeywordedStaticAbility { KeyWord = foundKw };
				return true;
			}
		
			string foundKwWithNumber = CommonTokens.KwStaticAbilitesWithNumber.FirstOrDefault( text.StartsWith );
			if (!string.IsNullOrWhiteSpace(foundKwWithNumber))
			{
				int number;
				if (int.TryParse(text.Substring(foundKwWithNumber.Length + 1), out number))
				{
					ability = new KeywordedStaticAbility { Amount = number, KeyWord = foundKwWithNumber };
					return true;
				}
			}
			return false;
		}


		public override string ToString()
		{
			return string.Format( "KwS: {0} {1}", KeyWord, Amount );
		}

		public AbContext SubParts { get; set; }
	}
}
