﻿using System;

namespace AbilityParser
{
	public static class CommonTokens
	{
		public static readonly char[] Quotes = new[] { '"' };
		public const char QuoteL2 = '‘';
		public const char QuoteL2Close = '\'';
		public const string ColonSpace = ": ";
		public static readonly string[] ActivationToken = new[] { ColonSpace};
		public const char EmDash = '—';
		public const string CommaSpace = ", ";
		public static readonly string[] CommaSpaceArr = new[] { CommaSpace };
		public static readonly char[] EmDashSpace = new[] { ' ', EmDash };
		public static readonly char[] TrimFromAbilities = new[] {' ', '.'};
		public static readonly string[] PeriodSpace = new[] { ". " };
		public static readonly char[] PlusMinus = new[] { '+', '-' };


		public static string[] KwStaticAbilites = new[]
		{
			"Flying", "Reach", "Vigilance", "Trample", "Defender", "Deathtouch", "Hexproof", "Shroud", "Phasing",
			"First strike", "Double strike", "Haste", "Lifelink", "Fear", "Intimidate", "Infect", "Wither", "Battle cry", "Exalted",
				
			"Sunburst", "Persist", "Modular—Sunburst", "Flanking", "Banding", "Horsemanship", "Shadow", "Changeling", "Haunt",
			"Hideaway",

			"Conspire", "Cascade", "Flash", "Storm", "Gravestorm", "Convoke", "Living weapon", "Totem armor", "Epic",
			"Retrace", "Rebound", "Split second", "Delve", "Provoke",
			"Vanishing"  // Tidewalker has it without number
		};

		public static string[] KwStaticAbilitesWithNumber = new[]
		{
			"Fading", "Amplify", "Rampage", "Bushido", "Modular", "Annihilator", "Ripple",
			"Bloodthirst", "Graft", "Vanishing", "Soulshift", "Devour", "Scry", "Dredge"
		};

		// may safely drop these words, because conditions are written in text anyway.
		public static readonly string[] UselessKeywords = new[] 
			{ "Metalcraft", "Morbid", "Threshold", "Radiance", "Domain", "Chroma", "Landfall", "Hellbent", "Kinship", "Join forces", "Sweep" };
		
		// These words contain significant information on ability activation. Though removed from the sentences to parse, they are to be kept.
		public static readonly string[] SignificantKeywords = new[] { "Grandeur", "Imprint", "Forecast", "Channel" };

		public static readonly string[] KwAbilitiesWithCost = new[] 
		{ 
			"Buyback", "Cumulative upkeep", "Cycling", "Echo", "Entwine", "Equip", "Prowl", "Madness", "Ninjutsu", "Replicate",
			"Flashback", "Kicker", "Multikicker", "Morph", "Recover", "Splice onto Arcane", "Evoke", "Unearth", "Fortify", "Transmute"
		};

		public const string LevelUp = "Level up";
		public const string ReinforceToken = "Reinforce";
		public const string SuspendToken = "Suspend";

		public const string ThisCardToken = "[ThisCard]";

		public const string TriggerAt = "At ";
		public static readonly string[] TriggerTokes = new[]  { TriggerAt, "When ", "Whenever " };
		public const string Until = "Until ";

		public const string Opponent = "opponent";
		public const string And = "and";
		public const string Or = "or";
		public const string CommaSpaceOr = CommaSpace + Or + " ";
		public const string AndOr = "and/or";
		public const string If = "if ";
		public const string TheNextTime = "the next time ";
		public const string Would = "would";
		public const string Instead = "instead";
		public const string AsLongAs = "As long as ";

		public const string Prevent = "prevent";
	}
}