﻿using System;
using System.Collections.Generic;
using System.Linq;
using AbilityParser.Filter;
using Magic.Utils;

namespace AbilityParser.Condition
{
	class FilteredCondition<T> : SimpleCondition<T>
	{
		public IFilter<T> Filter { get; set; }

		public override bool IsParsed()
		{
			return Filter.IsParsed() && base.IsParsed();
		}

		public override IEnumerable<UnknownPart> GetUnknownParts()
		{
			IEnumerable<UnknownPart> filters = Filter.GetUnknownParts();
			return filters.Union( base.GetUnknownParts() );
		}

		public override bool IsProxy()
		{
			return Filter.IsProxy() || base.IsProxy();
		}

		public override ICondition RemoveProxy()
		{
			Filter = Filter.RemoveProxy();
			return base.RemoveProxy();
		}

		public override string ToString()
		{
			return String.Format( "Condition: {0} {1}", Filter, MagicPredicate );
		}
	}
}
