﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AbilityParser.Entities;
using AbilityParser.Filter;
using AbilityParser.MagicPredicate;
using Magic.Utils;

namespace AbilityParser.Condition
{
	class SimpleCondition<T> : ICondition
	{
		public IMagicPredicate<T> MagicPredicate { get; set; }

		public virtual bool IsParsed()
		{
			return MagicPredicate.IsParsed();
		}

		public virtual IEnumerable<UnknownPart> GetUnknownParts()
		{
			return MagicPredicate.GetUnknownParts();
		}

		public virtual bool IsProxy()
		{
			return MagicPredicate.IsProxy();
		}

		public virtual ICondition RemoveProxy()
		{
			MagicPredicate = MagicPredicate.RemoveProxy();
			return this;
		}

		public override string ToString()
		{
			return String.Format( "Condition: {0}", MagicPredicate );
		}
	}
}
