﻿using System;
using AbilityParser.Ability;
using Magic.Mana;
using Magic.Utils;

namespace AbilityParser.Cost
{
	public class CostLoyalty : ParsedUnit<ICost>, ICost
	{
		private readonly int amount;
		private readonly bool isMinusX;

		public CostLoyalty(int _amount, bool _isMinusX = false)
		{
			isMinusX = _isMinusX;
			amount = _amount;
		}

		public override string ToString()
		{
			string sign = amount > 0 ? "+" : string.Empty;
			return String.Format( "Loyalty[{0}]", isMinusX ? "-X" : sign + amount );
		}


		public static readonly Parser<ICost> Parser = new ParserLoyalty();
		public class ParserLoyalty : Parser<ICost> {
			public override bool Can(string text)
			{
				return text == "0" || text[0] == '-' || text[0] == '+';
			}
			protected override ICost Parse(string text)
			{
				return text == "-X" ? new CostLoyalty( 0, true ) : new CostLoyalty( int.Parse( text ) );
			}
		}

	}
}