﻿using System;
using Magic.Mana;
using Magic.Utils;

namespace AbilityParser.Cost
{
	public class CostMana : ParsedUnit<ICost>, ICost
	{
		private readonly ManaCost manaCost;
		public CostMana( ManaCost _manaCost )
		{
			manaCost = _manaCost;
		}

		public override string ToString()
		{
			return String.Format( "Pay Mana[{0}]", manaCost );
		}

		public static readonly Parser<ICost> Parser = new ParserMana();
		private class ParserMana : Parser<ICost>
		{
			public override bool Can( string text )
			{
				return text[0] == '{' && text.IndexOf(' ') == -1;
			}
			protected override ICost Parse(string text)
			{
				ManaCost manaCost = ManaCost.Parse(text);
				return new CostMana(manaCost);
			}

		}
	}
}