﻿using AbilityParser.Entities;
using AbilityParser.Filter;
using AbilityParser.Rules;
using Magic.Utils;

namespace AbilityParser.Effect
{
	class ChangeCardState : ParsedUnit<IEffect>, IEffect
	{
		public readonly CardBinaryState State;
		public readonly IFilter<Card> Filter;
		public readonly bool From;
		public readonly bool To;

		public ChangeCardState(CardBinaryState state, IFilter<Card> filter, bool destState = true)
		{
			State = state;
			To = destState;
			From = !destState;
			Filter = filter;
		}

		public override string ToString()
		{
			return string.Format( "Set {0} of {1} to {2}", State, Filter, To );
		}

	}
}
