﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AbilityParser.Calculator;
using Magic.Mana;
using Magic.Utils;

namespace AbilityParser.Effect
{
	class GiveMana : IParseUnit<IEffect>, IEffect
	{
		public ICalculator<int> Amount;
		public ICalculator<ManaColor> Color;

		public override string ToString()
		{
			return String.Format( "Add {0} {1} to your manapool", Amount, Color );
		}

		public bool IsParsed()
		{
			return Amount.IsParsed() && Color.IsParsed();
		}

		public IEnumerable<UnknownPart> GetUnknownParts()
		{
			return Amount.GetUnknownParts().Union(Color.GetUnknownParts());
		}

		public bool IsProxy()
		{
			return Amount.IsProxy() && Color.IsProxy();
		}

		public IEffect RemoveProxy()
		{
			Amount = Amount.RemoveProxy();
			Color = Color.RemoveProxy();
			return this;
		}
	}
}
