﻿using System;
using AbilityParser.Condition;
using AbilityParser.Entities;
using Magic.Utils;

namespace AbilityParser.MagicPredicate
{
	class CounterPredicate : ParsedUnit<IMagicPredicate<Card>>, IMagicPredicate<Card>
	{
		public string CounterName { get; set; }
		public int MinAmount { get; set; }
		public int MaxAmount { get; set; }

		public override string ToString()
		{
			string count = string.Format( MaxAmount == int.MaxValue ? "{0}+" : "{0} to {1}", MinAmount, MaxAmount );
			return String.Format( "has {0} '{1}' counters", count, CounterName );
		}
	}
}
