﻿using System;
using System.Collections.Generic;
using AbilityParser.Entities;
using AbilityParser.MagicPredicate;
using Magic.Utils;

namespace AbilityParser.Trigger
{
	class TriggerAt : ITrigger
	{
		public IMagicPredicate<TimeLine> TimeMoment { get; private set; }
		public TriggerAt( string text )
		{
			TimeMoment = new UnparsedTurnPart( text );
		}

		public override string ToString()
		{
			return "Trigger @ " + TimeMoment;
		}

		public bool IsParsed()
		{
			return TimeMoment.IsParsed();
		}

		public IEnumerable<UnknownPart> GetUnknownParts()
		{
			return TimeMoment.GetUnknownParts();
		}

		public bool IsProxy()
		{
			return TimeMoment.IsProxy();
		}

		public ITrigger RemoveProxy()
		{
			TimeMoment = TimeMoment.RemoveProxy();
			return this;
		}
	}
}
