﻿using System;
using System.Collections.Generic;
using Magic.Utils;

namespace Magic.Cards
{
	public class CardRules : CardRulesInner
	{
		public CardSplitType splitType { get; internal set; }
		public CardRulesInner secondPart { get; internal set; }

		public readonly IDictionary<String, CardInSet> PrintedIn; 
		protected IDictionary<String, CardInSet> printedIn= new Dictionary<string, CardInSet>();

		public CardRules()
		{
			PrintedIn = ReadOnlyDictionary<String,CardInSet>.From( printedIn );
		}

		internal void RegisterPrinting(String cardSet, CardRarity rarity)
		{
			if(!printedIn.ContainsKey( cardSet ))
				printedIn.Add(cardSet, new CardInSet { Code = cardSet, Prints = 0, Rarity = rarity });

			printedIn[cardSet].Prints++;

		}
	}
}
