﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Magic.Mana;
using Magic.Utils;

namespace Magic.Cards
{
	public class CardRulesInner
	{
		public String Name { get; internal set; }
		public ManaCost Cost { get; internal set; }
		public CardType CardType { get; internal set; }
		public CardColor Color { get; internal set; }
		public string Power { get; internal set; }
		public string Toughness { get; internal set; }
		public short Loyalty { get; internal set; }

		public ReadOnlyCollection<String> Texts { get { return texts; } }
		public ReadOnlyCollection<IParseUnit<object>> Abilities { get { return ro_abilites; } }

		protected List<IParseUnit<object>> abilities;
		protected ReadOnlyCollection<IParseUnit<object>> ro_abilites;
		protected ReadOnlyCollection<String> texts;

		public CardRulesInner()
		{
			abilities = new List<IParseUnit<object>>();
			ro_abilites = new ReadOnlyCollection<IParseUnit<object>>(abilities);
		}

		public void setTexts(string[] texts0)
		{
			texts = new ReadOnlyCollection<string>( texts0 );
			abilities.Clear();

		}
		public void setAbilities(IEnumerable<IParseUnit<object>> ability, params bool[] parsedRules)
		{
			abilities.AddRange( ability );
		}

	}
}
