﻿using System;

namespace Magic.Cards
{
	public class CardSet : IComparable<CardSet>
	{
		public string Code { get; private set; }
		public string Name { get; private set; }
		public string Block { get; private set; }
		public DateTime ReleasedOn { get; private set; }


		public CardSet(DateTime release, String name, String code, String block) {
			Code = code;
			ReleasedOn = release;
			Block = block;
			Name = name;
		}

		public int CompareTo(CardSet other)
		{
			return other == null ? 1 : ReleasedOn.CompareTo( other.ReleasedOn );
		}

		public bool Equals( CardSet other )
		{
			if( ReferenceEquals( null, other ) ) return false;
			return ReferenceEquals( this, other ) || Equals( other.Code, Code );
		}

		public override bool Equals( object obj )
		{
			if( ReferenceEquals( null, obj ) ) return false;
			return ReferenceEquals( this, obj ) || Equals(obj as CardSet);
		}

		public override int GetHashCode()
		{
			return Code.GetHashCode();
		}
	}
}
