﻿using Magic.Common;

namespace Magic.Mana
{
	public class ManaColor
	{
		public byte Color { get; private set; }
		public string Name { get; private set; }
		public string Icon { get; private set; }


		private ManaColor() { }

		public static readonly ManaColor White = new ManaColor() { Color = MagicColor.White, Name = "White", Icon = "W"};
		public static readonly ManaColor Blue = new ManaColor() { Color = MagicColor.Blue, Name = "Blue", Icon = "U"};
		public static readonly ManaColor Black = new ManaColor() { Color = MagicColor.Black, Name = "Black", Icon = "B"};
		public static readonly ManaColor Red = new ManaColor() { Color = MagicColor.Red, Name = "Red", Icon = "R"};
		public static readonly ManaColor Green = new ManaColor() { Color = MagicColor.Green, Name = "Green", Icon = "G"};
		public static readonly ManaColor Colorless = new ManaColor() { Color = MagicColor.Colorless, Name = "Colorless", Icon = "1" };

		public override string ToString()
		{
			return string.Format( "{{{0}}}", Icon );
		}
	}
}
