﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Magic.Utils
{
	public abstract class Parser<T>
	{
		public abstract bool Can( string text );
		protected abstract T Parse(string text);
		public bool Try( string text, ref T ability )
		{
			if (!Can(text)) return false;
			ability = Parse( text );
			return true;
		}

		protected const string CommaSpace = ", ";
		protected const string CommaSpaceOr = ", or";
		protected int IndexOfCommaSpaceAfterSiblings(string text)
		{
			int iCs = text.IndexOf(CommaSpace);
			int next_iCs = text.IndexOf(CommaSpace, iCs + 2);
			int next_CsOr = text.IndexOf(CommaSpaceOr, iCs + 2);
			if (next_CsOr > 0 && next_iCs - iCs < 20) // expect sibling conditions
			{
				iCs = text.IndexOf(CommaSpace, next_CsOr + 5);
				if (iCs <= 0) { iCs = text.IndexOf(CommaSpace); }
			}
			return iCs;
		}
	}
}
