﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Magic.Utils
{
	using System;

	public sealed class Singleton<T> where T : class, new()
	{
		private static volatile T instance;
		private static readonly object syncRoot = new Object();

		public static T Instance
		{
			get
			{
				if (instance == null)
				{
					lock (syncRoot)
					{
						if (instance == null)
							instance = new T();
					}
				}

				return instance;
			}
		}
	}
 
}
