﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Magic.Utils
{
	public class UnknownPart
	{
		public readonly string Text;
		public readonly Type ParserClass;
		public readonly string TextType;

		public UnknownPart( string textType, string text, Type parserType )
		{
			Text = text;
			TextType = textType;
			ParserClass = parserType;
		}

		public override bool Equals(object obj)
		{
			if( ReferenceEquals( null, obj ) ) return false;
			if( ReferenceEquals( this, obj ) ) return true;
			return obj.GetType() == typeof( UnknownPart ) && Equals( (UnknownPart) obj );
		}

		public bool Equals( UnknownPart other )
		{
			if( ReferenceEquals( null, other ) ) return false;
			if( ReferenceEquals( this, other ) ) return true;
			return String.Compare( other.Text, Text, true) == 0 && Equals( other.ParserClass, ParserClass ) && Equals( other.TextType, TextType );
		}

		public override int GetHashCode()
		{
			unchecked
			{
				int result = ( Text != null ? Text.ToLower().GetHashCode() : 0 );
				result = ( result*397 ) ^ ( ParserClass != null ? ParserClass.GetHashCode() : 0 );
				result = ( result*397 ) ^ ( TextType != null ? TextType.GetHashCode() : 0 );
				return result;
			}
		}
	}
}
