﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Magic.Utils
{
	public abstract class UnparsedUnit<T> : IParseUnit<T> where T : IParseUnit<T>
	{
		protected string Text;
		protected T parsed;

		protected UnparsedUnit(string text)	{ Text = text; }
		public bool IsParsed() { return false; }
		public bool IsProxy() { return true; }

		public abstract T RemoveProxy();
		public abstract IEnumerable<UnknownPart> GetUnknownParts();

		public override string ToString()
		{
			return String.Format( "*Unparsed {0}* {1}", typeof(T).Name, Text);
		}

	}
}
