using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media;
using Magic.Cards;

namespace WpfRules
{
	public class CellColorFromCardColor : IValueConverter
	{
		public object Convert( object value, Type targetType, object parameter, CultureInfo culture )
		{
			CardPrinted cp = value as CardPrinted;
			CardColor color = cp.Rules.Color;
			
			if (color.IsWhite()) return Brushes.LightGoldenrodYellow;
			if (color.IsRed()) return Brushes.MistyRose;
			if (color.IsBlack()) return Brushes.Gray;
			if (color.IsBlue()) return Brushes.LightSteelBlue;
			if (color.IsGreen()) return Brushes.LightGreen;
			if (color.IsColorless()) return Brushes.LightGray;
			return Brushes.Goldenrod;

		}

		public object ConvertBack( object value, Type targetType, object parameter, CultureInfo culture )
		{
			throw new NotImplementedException();
		}
	}
}