using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media;
using Magic.Cards;

namespace WpfRules
{
	public class CellColorFromCardRarity : IValueConverter
	{
		public object Convert( object value, Type targetType, object parameter, CultureInfo culture )
		{
			CardPrinted cp = value as CardPrinted;
			CardRarity r = cp.Rarity;
			switch( r )
			{
				case CardRarity.BasicLand: return Brushes.DarkGreen;
				case CardRarity.Common: return Brushes.Black;
				case CardRarity.Uncommon: return Brushes.Gray;
				case CardRarity.Rare: return Brushes.DarkGoldenrod;
				case CardRarity.MythicRare: return Brushes.DarkOrange;
				case CardRarity.Special: return Brushes.Violet;
			}
			return Brushes.DarkRed;
		}

		public object ConvertBack( object value, Type targetType, object parameter, CultureInfo culture )
		{
			throw new NotImplementedException();
		}
	}
}