﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Windows.Data;
using Magic.Cards;

namespace WpfRules
{
	[ValueConversion(typeof(CardRarity), typeof(String))]
	public class RarityConverter : IValueConverter
	{
		private static readonly Dictionary<CardRarity, string> rareText = new Dictionary<CardRarity, string> { { CardRarity.NotApplicable, "-" }, { CardRarity.Common, "C" }, { CardRarity.Uncommon, "U" }, { CardRarity.Rare, "R" }, { CardRarity.MythicRare, "M" }, { CardRarity.Special, "S" }, { CardRarity.BasicLand, "L" } };
		public object Convert( object value, Type targetType, object parameter, CultureInfo culture )
		{
			CardPrinted cp = value as CardPrinted;
			return String.Format( "{0} {1}", rareText[cp.Rarity], cp.Set );
		}

		public object ConvertBack( object value, Type targetType, object parameter, CultureInfo culture )
		{
			throw new NotImplementedException();
		}
	}
}